import React, { Component } from 'react';
import PropTypes from 'prop-types';
import './Path.css';

export class Path extends Component {
  static propTypes = {
    startX: PropTypes.number.isRequired,
    startY: PropTypes.number.isRequired,
    controlX: PropTypes.number.isRequired,
    controlY: PropTypes.number.isRequired,
    endX: PropTypes.number.isRequired,
    endY: PropTypes.number.isRequired,
    width: PropTypes.number,
    color: PropTypes.string,
    handleMouseDown: PropTypes.func.isRequired,
    start: PropTypes.bool.isRequired,
    handleClose: PropTypes.func.isRequired,
    selected: PropTypes.bool.isRequired,
    handleSelectObject: PropTypes.func.isRequired,
  }

  static defaultProps = {
    width: 2,
    color: 'red',
  }

  render() {
    return ([
      this.props.selected ? <path strokeDasharray="5,5" stroke="gray" strokeWidth="2" d={`M${this.props.startX},${this.props.startY} L${this.props.controlX},${this.props.controlY}`} /> : '',
      this.props.selected ? <path strokeDasharray="5,5" stroke="gray" strokeWidth="2" d={`M${this.props.endX},${this.props.endY} L${this.props.controlX},${this.props.controlY}`} /> : '',
      <path onClick={this.props.handleSelectObject} className="path-line" fill="none" strokeWidth={this.props.width} stroke={this.props.color} d={` M${this.props.startX},${this.props.startY} Q ${this.props.controlX},${this.props.controlY} ${this.props.endX},${this.props.endY}`} />,
      this.props.selected ? <circle className="bezier-handler" onMouseDown={this.props.handleMouseDown} cx={this.props.controlX} cy={this.props.controlY} r="8" stroke="black" fill="white" /> : '',
      this.props.start ? <circle onClick={this.props.handleClose} className="start-handler" onMouseDown={this.props.handleMouseDown} cx={this.props.startX} cy={this.props.startY} r="5" stroke="black" fill="yellow" /> : '',
    ]
    );
  }
}

export default Path;
